<?php

namespace Dj3c1t\SourceMLBundle\Controller\Admin;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;

class CacheController extends Controller {

    public function indexAction(Request $request) {
        $em = $this->getDoctrine()->getManager();
        $configurationRepo = $em->getRepository("Dj3c1tAppBundle:Configuration");
        $lifetime_enabled = $configurationRepo->getConfiguration("sourceml.cache.lifetime_enabled");
        $lifetime_enabled = isset($lifetime_enabled) ? ($lifetime_enabled ? true : false) : false;
        $lifetime = $configurationRepo->getConfiguration("sourceml.cache.lifetime");
        $lifetime = isset($lifetime) ? $lifetime : "72";
        if($request->getMethod() == "POST") {
            $data = $request->request->all();
            try {
                if(isset($data["lifetime_enabled"])) {
                    if(!isset($data["lifetime"])) {
                        throw new \Exception("missing parameter");
                    }
                    if(!preg_match("/^[0-9]+$/", $data["lifetime"])) {
                        throw new \Exception("La durée de validité doit être un nombre entier");
                    }
                    $lifetime_enabled_conf = $configurationRepo->setConfiguration(
                        "sourceml.cache.lifetime_enabled",
                        "1"
                    );
                    $em->persist($lifetime_enabled_conf);
                    $lifetime_conf = $configurationRepo->setConfiguration(
                        "sourceml.cache.lifetime",
                        $data["lifetime"]
                    );
                    $em->persist($lifetime_conf);
                }
                else {
                    $lifetime_enabled_conf = $configurationRepo->setConfiguration(
                        "sourceml.cache.lifetime_enabled",
                        "0"
                    );
                    $em->persist($lifetime_enabled_conf);
                }
                $em->flush();
                $this->get('session')->getFlashBag()->add('success', "La configuration du cache a été enregistrée");
                return $this->redirect($this->generateUrl('sourceml_admin_cache'));
            }
            catch(\Exception $e) {
                $this->get('session')->getFlashBag()->add('error', $e->getMessage());
            }
        }
        return $this->render(
            'Dj3c1tSourceMLBundle:Admin:cache.html.twig',
            array(
                "lifetime_enabled" => $lifetime_enabled,
                "lifetime" => $lifetime
            )
        );
    }

    public function emptyAction() {
        $source_cache = $this->container->get('sourceml.source_cache');
        try {
            $source_cache->emptyCache();
            $this->get('session')->getFlashBag()->add('success', "Le cache a été vidé");
            return $this->redirect($this->generateUrl('sourceml_admin_cache'));
        }
        catch(\Exception $e) {
            $this->get('session')->getFlashBag()->add('error', $e->getMessage());
        }
        return $this->redirect($this->generateUrl('sourceml_admin_cache'));
    }

}
