<?php

namespace Dj3c1t\AppBundle\DataFixtures\ORM;

use Doctrine\Common\DataFixtures\FixtureInterface;
use Doctrine\Common\Persistence\ObjectManager;

use Dj3c1t\SourceMLBundle\Entity\SourceType;
use Dj3c1t\SourceMLBundle\Entity\AuthorRole;

class LoadSourceMLBaseData implements FixtureInterface {

    public function load(ObjectManager $manager) {
        $this->loadSourceTypes($manager);
        $this->loadAuthorRoles($manager);
    }

    public function loadSourceTypes(ObjectManager $manager) {
        $sourceTypes = array(
            "album",
            "track",
            "source",
        );
        foreach($sourceTypes as $sourceTypeName) {
            $sourceType = new SourceType();
            $sourceType->setName($sourceTypeName);
            $manager->persist($sourceType);
        }
        $manager->flush();
    }

    public function loadAuthorRoles(ObjectManager $manager) {
        $authorRoles = array(
            "admin",
            "editor",
            "contributor",
        );
        foreach($authorRoles as $authorRoleName) {
            $authorRole = new AuthorRole();
            $authorRole->setName($authorRoleName);
            $manager->persist($authorRole);
        }
        $manager->flush();
    }

}
